// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file JSONMessage.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool fastddsgen.
 */

#ifndef _FAST_DDS_GENERATED_JSONMESSAGE_H_
#define _FAST_DDS_GENERATED_JSONMESSAGE_H_

#include <array>
#include <bitset>
#include <cstdint>
#include <map>
#include <string>
#include <vector>

#include <fastcdr/cdr/fixed_size_string.hpp>
#include <fastcdr/xcdr/external.hpp>
#include <fastcdr/xcdr/optional.hpp>



#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(JSONMESSAGE_SOURCE)
#define JSONMESSAGE_DllAPI __declspec( dllexport )
#else
#define JSONMESSAGE_DllAPI __declspec( dllimport )
#endif // JSONMESSAGE_SOURCE
#else
#define JSONMESSAGE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define JSONMESSAGE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
class CdrSizeCalculator;
} // namespace fastcdr
} // namespace eprosima





/*!
 * @brief This class represents the structure JSONMessage defined by the user in the IDL file.
 * @ingroup JSONMessage
 */
class JSONMessage
{
public:

    /*!
     * @brief Default constructor.
     */
    eProsima_user_DllExport JSONMessage();

    /*!
     * @brief Default destructor.
     */
    eProsima_user_DllExport ~JSONMessage();

    /*!
     * @brief Copy constructor.
     * @param x Reference to the object JSONMessage that will be copied.
     */
    eProsima_user_DllExport JSONMessage(
            const JSONMessage& x);

    /*!
     * @brief Move constructor.
     * @param x Reference to the object JSONMessage that will be copied.
     */
    eProsima_user_DllExport JSONMessage(
            JSONMessage&& x) noexcept;

    /*!
     * @brief Copy assignment.
     * @param x Reference to the object JSONMessage that will be copied.
     */
    eProsima_user_DllExport JSONMessage& operator =(
            const JSONMessage& x);

    /*!
     * @brief Move assignment.
     * @param x Reference to the object JSONMessage that will be copied.
     */
    eProsima_user_DllExport JSONMessage& operator =(
            JSONMessage&& x) noexcept;

    /*!
     * @brief Comparison operator.
     * @param x JSONMessage object to compare.
     */
    eProsima_user_DllExport bool operator ==(
            const JSONMessage& x) const;

    /*!
     * @brief Comparison operator.
     * @param x JSONMessage object to compare.
     */
    eProsima_user_DllExport bool operator !=(
            const JSONMessage& x) const;

    /*!
     * @brief This function sets a value in member uuid
     * @param _uuid New value for member uuid
     */
    eProsima_user_DllExport void uuid(
            uint32_t _uuid);

    /*!
     * @brief This function returns the value of member uuid
     * @return Value of member uuid
     */
    eProsima_user_DllExport uint32_t uuid() const;

    /*!
     * @brief This function returns a reference to member uuid
     * @return Reference to member uuid
     */
    eProsima_user_DllExport uint32_t& uuid();


    /*!
     * @brief This function sets a value in member datetime
     * @param _datetime New value for member datetime
     */
    eProsima_user_DllExport void datetime(
            uint32_t _datetime);

    /*!
     * @brief This function returns the value of member datetime
     * @return Value of member datetime
     */
    eProsima_user_DllExport uint32_t datetime() const;

    /*!
     * @brief This function returns a reference to member datetime
     * @return Reference to member datetime
     */
    eProsima_user_DllExport uint32_t& datetime();


    /*!
     * @brief This function copies the value in member topic
     * @param _topic New value to be copied in member topic
     */
    eProsima_user_DllExport void topic(
            const std::string& _topic);

    /*!
     * @brief This function moves the value in member topic
     * @param _topic New value to be moved in member topic
     */
    eProsima_user_DllExport void topic(
            std::string&& _topic);

    /*!
     * @brief This function returns a constant reference to member topic
     * @return Constant reference to member topic
     */
    eProsima_user_DllExport const std::string& topic() const;

    /*!
     * @brief This function returns a reference to member topic
     * @return Reference to member topic
     */
    eProsima_user_DllExport std::string& topic();


    /*!
     * @brief This function copies the value in member message
     * @param _message New value to be copied in member message
     */
    eProsima_user_DllExport void message(
            const std::string& _message);

    /*!
     * @brief This function moves the value in member message
     * @param _message New value to be moved in member message
     */
    eProsima_user_DllExport void message(
            std::string&& _message);

    /*!
     * @brief This function returns a constant reference to member message
     * @return Constant reference to member message
     */
    eProsima_user_DllExport const std::string& message() const;

    /*!
     * @brief This function returns a reference to member message
     * @return Reference to member message
     */
    eProsima_user_DllExport std::string& message();

private:

    uint32_t m_uuid{0};
    uint32_t m_datetime{0};
    std::string m_topic;
    std::string m_message;

};

#endif // _FAST_DDS_GENERATED_JSONMESSAGE_H_



