#ifndef BYTE_SEQUENCE_HPP_10RLFUNF
#define BYTE_SEQUENCE_HPP_10RLFUNF

#include <vanetza/common/byte_buffer.hpp>
#include <functional>

namespace vanetza
{

/**
 * Create a random sequence of bytes
 * \param length Length of generated byte buffer
 * \param seed initializing random number generator
 */
ByteBuffer random_byte_sequence(std::size_t length, int seed = 0);

/**
 * Create generator function for random bytes
 * \param seed initializing random number generator
 * \return Generator function producing random bytes
 */
std::function<uint8_t()> random_byte_generator(int seed = 0);

} // namespace vanetza

#endif /* BYTE_SEQUENCE_HPP_10RLFUNF */

